#include <demo.h>
#include <bump.h>

void EnvMap(void)
{
  float nX,nY,nZ;
  int x,y;
  for ( y=0;y<256;y++)
    for ( x=0;x<256;x++)
      {
	nX=(x-128)/128.0;
	nY=(y-128)/128.0;
	nZ=1-sqrt(nX*nX+nY*nY);
	if (nZ<0) 
	  nZ=0;
	envmap[x+y*256]=(AMBIENT+((unsigned char)fmin(255,(nZ*DIFFUSE+nZ*nZ *SPECULAR))))/128.0f;
      }
}




void initBump(void)
{
  
  float tx,ty;
  int x,y;

  for (x=-128;x<128;x++)
    for (y=-128;y<128;y++)
      {
	tx=x/128;
	ty=y/128;
	vz[x+128][y+128] = (float)fmax( 1 - sqrt(tx*tx + ty*ty) , 0);
      }

  EnvMap();
}



void Bump(int lx1,int ly1, 
	  int lx2,int ly2, 
	  int lx3,int ly3, 
	  unsigned char *bumpmap)
{
  int nx,ny, nx2,ny2,nx3,ny3;
  int x,y;
  int offs=(XSIZ*4);
  int offb=XSIZ*4;
  int offb2=(XSIZ*4)+1;
  int offb3=(XSIZ*4)+2;

  unsigned char *s=screen;

  lx1+=128;
  ly1+=128;
  lx2+=128;
  ly2+=128;
  lx3+=128;
  ly3+=128;
 
  for (y=1;y<YSIZ-1;y++)
    {
      for (x=0;x<XSIZ;x++)
	{
	  nx=bumpmap[offb+4]-bumpmap[offb-4];
	  ny=bumpmap[offb+XSIZ*4]-bumpmap[offb-XSIZ*4];

	  nx2=bumpmap[offb2+4]-bumpmap[offb2-4];
	  ny2=bumpmap[offb2+XSIZ*4]-bumpmap[offb2-XSIZ*4];

	  nx3=bumpmap[offb3+4]-bumpmap[offb3-4];
	  ny3=bumpmap[offb3+XSIZ*4]-bumpmap[offb3-XSIZ*4];

	  nx-=(x-lx1);
	  ny-=(y-ly1);
	  nx2-=(x-lx2);
	  ny2-=(y-ly2);
	  nx3-=(x-lx3);
	  ny3-=(y-ly3);
	  if (nx>255 || nx<0) nx=255;
	  if (ny>255 || ny<0) ny=255;
	  if (nx2>255 || nx2<0) nx2=255;
	  if (ny2>255 || ny2<0) ny2=255;
	  if (nx3>255 || nx3<0) nx3=255;
	  if (ny3>255 || ny3<0) ny3=255;

	  s[offs]=(bumpmap[offb+4]*envmap[nx+ny*256]*1.0f);
	  s[offs+1]=(bumpmap[offb2+4]*envmap[nx2+ny2*256]*1.0f);
	  s[offs+2]=(bumpmap[offb2+4]*envmap[nx3+ny3*256]*1.0f);
	  offs+=4;
	  offb+=4;
	  offb2+=4;
	  offb3+=4;
	}
    }
}



