#ifndef __FONT_H_
#define __FONT_H_

#include <ft2build.h>  
#include FT_FREETYPE_H

FT_Library library; 

typedef struct _sFont
{
  unsigned char buffer[64*64];
  int x,y;
  int w,h;
}sFont;

sFont fontRender[94];

typedef struct _sOutlineObj
{
  int count;
  sVector *points;
}sOutlineObj;

typedef struct _sOutline
{
  int objCount;
  sOutlineObj *obj;
}sOutline;

int initFont(void);
int makeFontTexture(FT_GlyphSlot slot, int id);
void drawChar(unsigned char tid, int px, int py, float size, float r, float g, float b);
void drawString(unsigned char *string, int px, int py, float size, float r, float g, float b);
sOutline *loadOutline(unsigned char *filename);
void printOutline(sOutline *line);

#endif /*__FONT_H_*/
