#include <demo.h>
#include <sprites.h>
#include <loadpng.h>


sSprite *loadPng(unsigned char *name)
{
  FILE* pngfile=NULL;
  unsigned char header[8];
  png_data data;
  int trafo=PNG_TRANSFORM_PACKING|PNG_TRANSFORM_EXPAND;
  int bit_depth, color_type, interlace_type, compression_type, filter_method;
  unsigned int i,j;
  png_bytepp row_pointers;
  unsigned char *new;
  sSprite *spr;

  
  pngfile=fopen(name, "rb");

  if (pngfile==NULL)  
      return NULL;
  if (fread(header,8,1,pngfile)!=1)
      return NULL;
  if (png_sig_cmp(header,0,8))
      return NULL;
  
  
  data.png_ptr=png_create_read_struct
    (PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
  if (!data.png_ptr)
      return NULL;
  
  data.info_ptr=png_create_info_struct(data.png_ptr);
  if (!data.info_ptr)
    {
      png_destroy_read_struct(&data.png_ptr, (png_infopp)NULL, (png_infopp)NULL);
      return NULL;
    }

  data.end_info=png_create_info_struct(data.png_ptr);
  if (!data.end_info)
    {
      png_destroy_read_struct(&data.png_ptr, &data.info_ptr, (png_infopp)NULL);
      return NULL;
    }
    
  if (setjmp(png_jmpbuf(data.png_ptr)))
    {
      png_destroy_read_struct(&data.png_ptr, &data.info_ptr, &data.end_info);
      return NULL;
    }
    
  png_init_io(data.png_ptr, pngfile);
  png_set_sig_bytes(data.png_ptr,8);
  
  png_read_png(data.png_ptr, data.info_ptr, trafo , NULL);

  
  png_get_IHDR(data.png_ptr, data.info_ptr, &data.width, &data.height, &bit_depth, &color_type,&interlace_type, &compression_type, &filter_method);
                 
  switch(color_type)
    {
    case PNG_COLOR_TYPE_RGB_ALPHA:
      break;
    default:
      printf("not supported color type\n");
      break;
    }

    
  row_pointers = png_get_rows(data.png_ptr, data.info_ptr);
  new = (unsigned char*) malloc(data.width*data.height*4);
  spr = malloc(sizeof(sSprite));
  spr->pixels = malloc(data.width*data.height*4);

  for(j=0;j<data.height;j++)    
    for(i=0;i<data.width*4;i++)
      ((unsigned char*)spr->pixels)[i+j*data.width*4] = row_pointers[j][i];
    
  spr->width = data.width;
  spr->height = data.height-1;
    
  if((data.width&1))
    {
      spr->width = data.width;
      spr->height = data.height;
	
    }  
  else
    {
      spr->width = data.width;

      if(data.height>32)
	{
	  spr->height = data.height-10;
	}
      else
	spr->height = data.height-1;
    }
    
    
  /*Stored in BGRA*/
  for(i=0;i<((spr->width)*spr->height*4);i+=4)
    {
      unsigned char *s = (unsigned char*) spr->pixels; 
      unsigned char r,g,b,a;

      r = s[i];
      g = s[i+1];
      b = s[i+2];
      a = s[i+3];

      s[i] = b;
      s[i+1] = g; 
      s[i+2] = r;
      s[i+3] = a;
    }
  free(data.end_info);
  free(data.info_ptr);
  free(new);

  fclose(pngfile);

  return spr;
}
