#include <demo.h>
#include <3d.h>
#include <metaballs.h>


int gx,gy,gz,n;
float diffx, diffy, diffz, distance;

sVector metaball[NB_METABALLS];


void metaballInit(void)
{
  int i;
  for(i=0;i<NB_METABALLS;i++)
    {
      metaball[i].x = (rand()%16)+16;
      metaball[i].y = (rand()%16)+16;
      metaball[i].z = (rand()%16)+16;
    }
  metaballID = NULL;

}


void metaballUpdatePos(int ticks)
{
  int i;
  for(i=0;i<NB_METABALLS;i++)
    {
      metaball[i].x = i;
      metaball[i].y = (sin(ticks)*16)+8;
      metaball[i].z = 0;
    }
  metaballID = NULL;


}

void metaballCompute(void)
{
  float average;
  int i;

  close3dEngine();
  init3dEngine();


  if(metaballID!=NULL)
    {
      free(metaballID);

      for(i=0;i<metaballCount;i++)
	scene->object[i].visible = 0;
    } 

  metaballCount = 0;
  metaballID = malloc(1);


  for(gz=0;gz<GRILLE_Z;gz++)                
    {
      for(gy=0;gy<GRILLE_Y;gy++)
	{
	  for(gx=0;gx<GRILLE_X;gx++)       
	    {
	      metagrille[gx][gy][gz]=0.0;
	      for(n=0;n<NB_METABALLS;n++)
		{
		  diffx=gx-metaball[n].x; 
		  diffy=gy-metaball[n].y;
		  diffz=gz-metaball[n].z;
		  distance=1.0f/((diffx*diffx) + (diffy*diffy) + (diffz*diffz));
		  metagrille[gx][gy][gz]+=distance;
		}
	    }
	}
    }


  for(gz=0;gz<GRILLE_Z-1;gz++)                
    {
      for(gy=0;gy<GRILLE_Y-1;gy++)
	{
	  for(gx=0;gx<GRILLE_X-1;gx++)       
	    {
	      average = (metagrille[gx+1][gy][gz] +
			 metagrille[gx+1][gy+1][gz] +
			 metagrille[gx+1][gy+1][gz+1] +
			 metagrille[gx+1][gy][gz+1] +
			 metagrille[gx][gy][gz] +
			 metagrille[gx][gy+1][gz] +
			 metagrille[gx][gy+1][gz+1] +
			 metagrille[gx][gy][gz+1])/8.0f;
	    
	         if(average>0.01)
		{

		  metaballID = realloc(metaballID, sizeof(int)*(metaballCount+1));
		  metaballID[metaballCount] = addCube(1,1,1,gx-16,gy-16,gz-16);
		  moveObject(metaballID[metaballCount], gx,gy,(gz));
	
		  colorObject(metaballID[metaballCount], average*255,0,0 );
		  
		  metaballCount++;
		  }

		 

	      
	      average=0;
	    }
	}
    }
  

  printf("%d cubes\n", metaballCount);


}


void metaballPrint(void)
{
  int x,y;

  printf("-----------------------------------------------\n");

  for(y=0;y<GRILLE_Y;y++)
    {
      for(x=0;x<GRILLE_X;x++)
	printf("%02d ", (int)(metagrille[x][y][GRILLE_Z/2]*1000.0f));
      printf("\n");
    }

}
