#ifndef __PARTICLES_H_
#define __PARTICLES_H_

#include <interpolation.h>

#define RAND_TABLE_MAX 10000

typedef struct _sParticle
{
  float ex, ey, ez;   /* emiter position */
  float x,y,z;        /* Individual Position */
  float vx,vy, vz;    /* Directionnal vector */

  float speed;
  float life;
  int visible;

}sParticle;


typedef struct _sParticleEmitter
{
  int nbParticle;
  float lifetime;
  float gravity;
  float max_speed;
  float elastness;
  float up_speed;
  float size;
  float far;
  int init;
  sSprite *sprite;
  sParticle *particles;

  int objectId;
  sObject *object;

}sParticleEmitter;

int nbEmitters;


typedef struct _vector 
{
  float x,y,z;
}vector;

typedef struct _sSystem
{
  int count;
  int *particles;
  sCurve *curve;
}sSystem;




int initParticles(int count, float lifetime, float max_speed, float gravity, float up_speed, float far, unsigned char *sprite);
void regenerateParticle(int id, int part, float x, float y, float z);
void updateParticles(int id, float x, float y, float z, int ticks);
void convertParticleToObject(int id);
sObject *particleGetObject(int id);
int particleGetObjectId(int id);
void drawParticles(int id);
sSystem *createParticlesFromObject(unsigned char *filename);



inline float GET_RAND(void);
float rand_table[RAND_TABLE_MAX];
int rand_offset;


#endif
